//-----------------------------------------------------------------
// JogHome.h - Created Fred Foscalina
// Header file for jogging and homing
//-----------------------------------------------------------------
//
//$Modtime: 5/07/13 1:40p $
//$Revision: 2 $
//$Author: Fredf $ 

#ifndef __JOGHOME_H__	// don't allow multiple loads
#define __JOGHOME_H__

// Globals defined
#define XAXIS 1
#define YAXIS 2
#define ZAXIS 3
#define AAXIS 4

#define PosLimitDisable			$20000
#define OutOfSwitchLength		10000

#define JogVarDist				CMD"J:*"
#define JogVarPos				CMD"J=*" 
#define JogStopAll 				CMD"#1J/#2J/#3J/"

#define JogXYPlus				CMD"#1J+#2J+"
#define JogXYMinus				CMD"#1J-#2J-"
#define JogXYZPlus				CMD"#1J+#2J+#3J+"
#define JogXYZMinus				CMD"#1J-#2J-#3J-"
#define JogXYVarDistance		CMD"#1J:*#2J:*"
#define JogXYVarPosition		CMD"#1J=*#2J=*"
#define JogXYToHome				CMD"#1J=0#2J=0"

///////////////////////////////////////////
// X Axis variables for Jog
///////////////////////////////////////////
#define FlagModeX				I124
#define XPosScale				(I108*32)
//#define XActualPos				P4511

#define JogXPlus				CMD"#1J+"
#define JogXMinus				CMD"#1J-"
#define JogXHoming				CMD"#1HM"
#define JogXStop				CMD"#1J/"
#define JogXVarDistance			CMD"#1J:*"
#define JogXVarPosition			CMD"#1J=*"
#define JogXToHome				CMD"#1J=0"
#define JogXPlusTrigger			CMD"#1J:100000^0"
#define JogXMinusTrigger		CMD"#1J:-100000^0"


///////////////////////////////////////////
// Y Axis variables for Jog
///////////////////////////////////////////
#define FlagModeY				I224
#define YPosScale				(I208*32)
//#define YActualPos				P4521

#define JogYPlus				CMD"#2J+"
#define JogYMinus				CMD"#2J-"
#define JogYHoming				CMD"#2HM"
#define JogYStop				CMD"#2J/"
#define JogYVarDistance			CMD"#2J:*"
#define JogYVarPosition			CMD"#2J=*"
#define JogYToHome				CMD"#2J=0"
#define JogYPlusTrigger			CMD"#2J:100000^0"
#define JogYMinusTrigger		CMD"#2J:-100000^0"


///////////////////////////////////////////
// Z Axis variables
///////////////////////////////////////////
#define FlagModeZ				I324
#define ZPosScale				(I308*32)
//#define ZActualPos				P4531

#define JogZPlus				CMD"#3J+"
#define JogZMinus				CMD"#3J-"
#define JogZHoming				CMD"#3HM"
#define JogZStop				CMD"#3J/"
#define JogZVarDistance			CMD"#3J:*"
#define JogZVarPosition			CMD"#3J=*"
#define JogZToHome				CMD"#3J=0"
#define JogZPlusTrigger			CMD"#3J:100000^0"
#define JogZMinusTrigger		CMD"#3J:-100000^0"

///////////////////////////////////////////
// 4th Axis variables
///////////////////////////////////////////
#define FlagMode4				I424
#define APosScale				(I408*32)
//#define 4ActualPos				P4531

#define Jog4Plus				CMD"#4J+"
#define Jog4Minus				CMD"#4J-"
#define Jog4Homing				CMD"#4HM"
#define Jog4Stop				CMD"#4J/"
#define Jog4VarDistance			CMD"#4J:*"
#define Jog4VarPosition			CMD"#4J=*"
#define Jog4ToHome				CMD"#4J=0"



// set up default pointer variables
ActualPosM->D:ActualPosXAddr
PosBiasM->D:PosBiasXAddr
JogVarDistanceM->L:JogVarDistanceXAddr
JogVarPositionM->L:JogVarDistanceXAddr
DesiredVelZeroM->X:ServoSCXAddr,13,1
InPositionM->Y:StatusXAddr,0,1
PosLimitM->X:ServoSCXAddr,21,1
NegLimitM->X:ServoSCXAddr,22,1

///////////////////////////////////////////
// Home SPECIFIC VARIABLES DEFINED BELOW
///////////////////////////////////////////

///////////////////////////////////////////
// X Axis variables for Home
///////////////////////////////////////////
#define XPosLimitDefault		100
#define XNegLimitDefault		-650000
#define XHomeOffsetDefault		0
#define XWaitTime				70

///////////////////////////////////////////
// Y Axis variables for Home
///////////////////////////////////////////
#define YPosLimitDefault		100
#define YNegLimitDefault		-395000
#define YHomeOffsetDefault		0
#define YWaitTime				70

///////////////////////////////////////////
// Z Axis variables for Home
///////////////////////////////////////////
#define ZPosLimitDefault		100
#define ZNegLimitDefault		-1860000
#define ZHomeOffsetDefault		0
#define ZWaitTime				70

///////////////////////////////////////////
// 4th Axis variables for Home
///////////////////////////////////////////
#define 4PosLimitDefault		100
#define 4NegLimitDefault		-1860000
#define 4HomeOffsetDefault		0
#define 4WaitTime				70

#endif